<cfcomponent displayname="No hashing (store passwords as plain text)" hint="I store passwords in the clear. I make no attempt to hide the password." extends="PasswordHash"
			alias="none" seq="10000" bCaseSensitive="false">
	
	<cffunction name="matchesHashFormat" hint="Does the string match the format for this hash?" access="public" returntype="boolean">
		<cfargument name="input" type="string" hint="String that may be a password hash" required="true" />
		<!--- Any string is a possible plaintext password --->
		<cfreturn true />
	</cffunction>

	<cffunction name="encode" hint="Convert a clear password to its hashed value" access="public" returntype="string">
		<cfargument name="password" type="string" hint="Input password" required="true" />

		<cfreturn arguments.password />
	</cffunction>

	<cffunction name="passwordMatch" hint="Compare a plain password against a hashed string" access="public" returntype="boolean">
		<cfargument name="password" type="string" hint="Input password" required="true" />
		<cfargument name="hashedPassword" type="string" hint="Hashed password string" required="true" />
		<cfargument name="bCheckHashStrength" type="string" default="false" hint="If true, the hash strength of the hashed password must also match those generated by encode()" />
		
		<cfif this.bCaseSensitive>
			<cfreturn not Compare(arguments.password,arguments.hashedPassword) />
		<cfelse>
			<cfreturn not CompareNoCase(arguments.password,arguments.hashedPassword) />
		</cfif>
	</cffunction>

</cfcomponent>